Subject: [ofa-general] Re: [PATCH v2] iw_cxgb3: Support "iwarp-only" interfaces to avoid 4-tuple conflicts.

From: Steve Wise <[email-masked]>
Date: Fri, 21 Sep 2007 10:10:46 -0500

Evgeniy Polyakov wrote:
> Hi Steve.
> 
> On Mon, Sep 17, 2007 at 10:25:04AM -0500, Steve Wise ([email-masked]) wrote:
>>> Does creating the whole new netdevice is a too big overhead, or is it
>>> considered bad idea?
>> I think its too big overhead, and pretty invasive on the low level cxgb3 
>> driver.  I think having a device in the 'ifconfig -a' after iw_cxgb3 is 
>> loaded and devices discovered would be a good thing for the admin.  This 
>> is the angle Roland suggested.  I'm just not sure how to implement it.
>>
>> But if someone could explain how I might create this full netdevice as a 
>> pseudo device on top of the real one, maybe I could implement it.
>>
>> Note that non TCP traffic still needs to utilize this interface for ND 
>> to work properly with the RDMA core.
> 
> Just a though - what about allowing secondary addresses with the same
> address as main one? I.e. change bit of the core code to allow creating
> aliases with the same address as main device, so that you would be able
> to create ':iw' alias during rdma device initialization?
> 

The problem is that on rdma route/address resolution the rdma core CM 
uses the routing table to look up which local device to use.  So what we 
need is separate ip subnets for rdma vs non rdma tcp.

Also, to avoid the original issue of 4-tuple conflicts, the rdma device 
_must_ listen on specific local "rdma-only" ip addresses and thus they 
must be not the same address as that used for native host tcp traffic.

Steve.